<template>
  <v-list-item
    :x-data="person.nick"
    @click="selectUser(index)"
    v-touch-hold="onHold"
    class="person-item"
    link
  >
    <v-list-item-icon>
      <!-- <q-img
        lazy-src="https://picsum.photos/id/11/10/6"
        :class="{ 'logged-out': !person.loggedIn }"
        max-height="120"
        max-width="60"
        :src="photo"
      /> -->
      <img
        :src="photo"
        :class="{
          'logged-out': !person.loggedIn,
          selected: selectedPerson === persons[index],
        }"
        style="max-height: 120px; max-width: 60px"
      />
    </v-list-item-icon>

    <v-list-item-content>
      <v-list-item-title style="display: flex; flex-direction: row">
        {{ person?.nick }}

        ({{ person.nrOfMessages }})
        <div v-if="person.blocks">
          Użytkownik {{ person.nick }} Cię zablokował
        </div>
        <div v-if="person.blocked">
          Zablokował{{ user.sex ? 'eś' : 'aś' }} {{ person.nick }}
        </div>
        <!-- <v-tooltip v-if="person.blocked" bottom>
          <template v-slot:activator="{ on, attrs }">
            <span v-bind="attrs" v-on="on">
              <v-icon color="error">mdi-cancel</v-icon>
            </span>
          </template>
          <span> Użytkownik {{ person?.nick }} Cię zablokował </span>
        </v-tooltip> -->

        <!-- <v-tooltip v-if="person.blocks" bottom>
          <template v-slot:activator="{ on, attrs }">
            <span v-bind="attrs" v-on="on">
              <v-icon color="error">mdi-cancel</v-icon>
            </span>
          </template>
          <span>
            Zablokowałeś użytkownika {{ person?.nick }}.<br />
            kliknij prawym przyciskiem myszy by go odblokować
          </span>
        </v-tooltip> -->
        <!-- <v-badge
          style="position: relative; left: 5px"
          v-if="person.nrOfMessages > 0 && selectedPerson.nick !== person.nick"
          color="info"
          :content="person.nrOfMessages"
        ></v-badge> -->
      </v-list-item-title>
    </v-list-item-content>
  </v-list-item>
  <q-dialog v-model="blockDialog" persistent style="color: #ffffff">
    <q-btn @click="blockUser" flat label="blokuj użytkownika" v-close-popup />
    <q-btn @click="unBlockUser" flat label="chcę mieś kontakt" v-close-popup />
  </q-dialog>
  <q-dialog v-model="blockDialog">
    <q-card>
      <q-card-actions align="right">
        <q-btn
          @click="blockUser"
          flat
          label="blokuj użytkownika"
          color="primary"
          v-close-popup
        />
        <q-btn
          @click="unBlockUser"
          flat
          label="chcę mieć kontakt"
          color="primary"
          v-close-popup
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script setup lang="ts">
import { ref, onMounted, defineEmits } from 'vue';

import Person from '../interfaces/Person';

import { useUserStore } from '../stores/user';
import { api } from '../boot/axios';

defineOptions({
  name: 'PersonInList',
});

export interface PersonInListProps {
  selectUser: (index: number) => void;
  getFriends: () => void;
  person: Person;
  persons: Person[];
  index: number;
  selectedPerson: Person | null | undefined;
}
const emit = defineEmits(['userBlocked', 'userUnblocked']);
const store = useUserStore();
const { user } = store;
const props = withDefaults(defineProps<PersonInListProps>(), {});

const photo = ref<string | undefined>(undefined);
const blockDialog = ref<boolean>(false);

onMounted(() => {
  api
    .post('/user/get-friend-image', {
      uuid: user.uuid,
      friendNick: props.person.nick,
    })
    .then(({ data }) => {
      for (let i = 0, max = data.length; i < max; i++) {
        if (data[i].fromNick === props.person.nick) {
          photo.value = JSON.parse(data[i].fromPhotos).profile;
          return;
        }
        if (data[i].toNick === props.person.nick) {
          photo.value = JSON.parse(data[i].toPhotos).profile;
          return;
        }
      }
      console.log(data);
    })
    .catch((e) => {
      console.error(e);
    });

  // const updateComponent = () => {
  //   photo.value = null; // or any other logic needed to refresh the component
  // };

  // Assuming $bus is a global event bus, you might need to import or access it similarly
  // Here it is assumed to be available in the current scope
  // $bus.$on('block-user', updateComponent);
  // $bus.$on('un-block-user', updateComponent);

  // // Clean up listeners when the component is unmounted
  // onUnmounted(() => {
  //   $bus.$off('block-user', updateComponent);
  //   $bus.$off('un-block-user', updateComponent);
  // });
});
function onHold() {
  if (!props.person.blocks) {
    blockDialog.value = true;
  }
}

function blockUser() {
  api
    .put('/user/block', {
      uuid: user.uuid,
      nick: props.person.nick,
    })
    .then((data) => {
      console.log(data);
      if (data.status === 200) {
      }
      emit('userBlocked', props.person.nick);
      props.getFriends();
      blockDialog.value = false;
    })
    .catch((err) => {
      console.error(err);
    });
}

function unBlockUser() {
  api
    .put('/user/unblock', {
      uuid: user.uuid,
      nick: props.person.nick,
    })
    .then((data) => {
      // if(data.status ==='NOT OK') {
      //   return;
      // }
      console.log(data);

      emit('userUnblocked', props.person.nick);
      props.getFriends();
      blockDialog.value = false;
    })
    .catch((err) => {
      console.error(err);
    });
}
</script>

<style scoped lang="scss">
.person-item {
  margin-top: 10px;
  .v-list-item--dense .v-list-item__icon,
  .v-list--dense .v-list-item .v-list-item__icon {
    height: 69px;
  }

  .logged-out {
    filter: grayscale(80%);
  }
  .selected {
    outline: 2px solid #101010;
    transform: scale(1.2);
  }
}
</style>
